﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("191A8ACC-65E7-4599-B8F3-445CDA8255E0"), ProgIdAttribute("adx_ol_vb_ctxMenuItems.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents
    Private adxCommandBar As AddinExpress.MSO.ADXCommandBar = Nothing

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        '
        'adxOutlookEvents
        '
        '
        'AddinModule
        '
        Me.AddinName = "adx_ol_vb_ctxMenuItems"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub
 
#End Region
 
#Region " Add-in Express automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Please add any initialization code to the AddinInitialize event handler
 
    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property


    Private Sub DoCommandBarsUpdate(ByVal Sender As Object)
        '
        Dim CurrentNameSpace As Outlook.NameSpace = OutlookApp.GetNamespace("MAPI")
        Dim ActiveExplorer As Outlook.Explorer = OutlookApp.ActiveExplorer()
        If (ActiveExplorer IsNot Nothing) And (CurrentNameSpace IsNot Nothing) Then
            Dim DefaultFolder As Outlook.MAPIFolder = CurrentNameSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderCalendar)
            Dim CurrentFolder As Outlook.MAPIFolder = ActiveExplorer.CurrentFolder
            If (DefaultFolder IsNot Nothing) And (CurrentFolder IsNot Nothing) Then
                If (CurrentFolder.EntryID = DefaultFolder.EntryID) Then
                    Me.CommandBarsObj = ActiveExplorer.CommandBars
                    Dim ContextBar As Office.CommandBar = Me.FindCommandBarObj("Context Menu")
                    If ContextBar IsNot Nothing Then
                        If (ContextBar.Controls.Count > 0) Then
                            Dim StandardNewButton As Office.CommandBarControl = Nothing
                            Dim NewButton As Office.CommandBarControl = Nothing
                            Try
                                StandardNewButton = ContextBar.Controls(1)
                                If (StandardNewButton IsNot Nothing) And _
                                  ((StandardNewButton.Caption = "New App&ointment") Or _
                                   (StandardNewButton.Caption = "&Open")) Then
                                    NewButton = ContextBar.FindControl(Office.MsoControlType.msoControlButton, Type.Missing, "MY_UNIQUE_TAG_VB", Type.Missing, Type.Missing)
                                    If (NewButton Is Nothing) Then
                                        ContextBar.Reset()
                                        ContextBar.Protection = Office.MsoBarProtection.msoBarNoProtection
                                        If (adxCommandBar Is Nothing) Then
                                            adxCommandBar = New AddinExpress.MSO.ADXCommandBar
                                            adxCommandBar.CommandBarObj = ContextBar
                                        Else
                                            adxCommandBar.Controls.Clear()
                                        End If

                                        Dim adxNewButton As AddinExpress.MSO.ADXCommandBarButton = New AddinExpress.MSO.ADXCommandBarButton
                                        adxNewButton.ControlTag = "MY_UNIQUE_TAG_VB"
                                        adxNewButton.Before = 0
                                        adxNewButton.Temporary = True
                                        adxNewButton.BeginGroup = True
                                        adxNewButton.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonCaption
                                        adxNewButton.Caption = "Test Button"
                                        AddHandler adxNewButton.Click, AddressOf Me.DoClick

                                        If adxCommandBar.Controls.Add(adxNewButton) IsNot Nothing Then
                                            adxNewButton.ControlObj = ContextBar.Controls.Add(Office.MsoControlType.msoControlButton, Type.Missing, Type.Missing, Type.Missing, Type.Missing)
                                            adxNewButton.UpdateControlObj(Me)
                                        Else
                                            Marshal.ReleaseComObject(NewButton)
                                        End If

                                        Marshal.ReleaseComObject(StandardNewButton)
                                    End If
                                End If
                            Catch
                                '
                            End Try
                        End If
                        Marshal.ReleaseComObject(ContextBar)
                    End If
                    Me.CommandBarsObj = Nothing
                End If
                Marshal.ReleaseComObject(DefaultFolder)
                Marshal.ReleaseComObject(CurrentFolder)
            End If
            Marshal.ReleaseComObject(ActiveExplorer)
            Marshal.ReleaseComObject(CurrentNameSpace)
        End If

    End Sub

    Private Sub DoClick(ByVal Sender As Object)
        MessageBox.Show(CType(Sender, AddinExpress.MSO.ADXCommandBarControl).Caption, "Add-in Express .NET (VB)")
    End Sub

    Private Sub adxOutlookEvents_CommandBarsUpdate(sender As System.Object, e As System.EventArgs) Handles adxOutlookEvents.CommandBarsUpdate
        DoCommandBarsUpdate(Me)
    End Sub

End Class

